Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	Dim ps2000_handle As Short
	Dim mv_a As Short
	Dim time_interval As Integer
	Dim time_units As Short
	Dim oversample As Short
	Dim time_indisposed As Integer
	Dim slow_collect As Boolean
	Dim streaming As Boolean
	Dim voltage_range(8) As Short
	
	Public Sub open_unit()
		Dim S As New VB6.FixedLengthString(10)
		Dim i As Short
		
		lstChannelA.Items.Clear()
		lstMessage.Items.Clear()
		lstMessage.Items.Add(("Opening PS2000"))
		
		ps2000_handle = ps2000_open_unit()
		If ps2000_handle > 0 Then
			lstMessage.Items.Clear()
			lstMessage.Items.Add(("PS2000 opened"))
			
			i = ps2000_set_ets(ps2000_handle, 0, 0, 0)
			Call Channel_select_Click()
			
		Else
			lstMessage.Items.Clear()
			lstMessage.Items.Add(("Unable to open"))
		End If
		
		
	End Sub
	
	Private Sub Channel_select_Click()
		
		Call ps2000_set_channel(ps2000_handle, 0, 1, 0, cboVoltageA.SelectedIndex + 3)
		
	End Sub
	
	Private Sub Close_Renamed_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Close_Renamed.Click
		If (ps2000_handle > 0) Then
			ps2000_stop(ps2000_handle)
			Call ps2000_close_unit(ps2000_handle)
			lstMessage.Items.Clear()
			lstMessage.Items.Add(("PS2000 closed"))
			ps2000_handle = 0
		Else
			Call ps2000_close_unit(ps2000_handle)
			lstMessage.Items.Clear()
			lstMessage.Items.Add(("PS2000 Not Opened"))
		End If
		
	End Sub
	
	Private Sub Form1_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		Call ps2000_close_unit(ps2000_handle)
	End Sub
	
	Private Sub Stop_Renamed_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Stop_Renamed.Click
		slow_collect = False
		ps2000_stop(ps2000_handle)
		Slow.Enabled = True
	End Sub
	
	
	Private Sub Fast_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Fast.Click
		
		Dim running As Short
		Dim ready As Short
		Dim Values_a(200000) As Short
		Dim Values_b(200000) As Short
		Dim Values_c(200000) As Short
		Dim Values_d(200000) As Short
		Dim volts_a As Short
		Dim no_of_values As Short
		Dim i As Short
		Dim timebase As Short
		Dim no_of_samples As Short
		Dim max_samples As Integer
		Dim overflow As Short
		Dim ok As Short
		'Dim max_samples As Long
		
		Call Stop_Renamed_Click(Stop_Renamed, New System.EventArgs())
		
		If ps2000_handle Then
			
			no_of_values = 1024
			timebase = 13
			
			Call Channel_select_Click()
			Call ps2000_set_ets(ps2000_handle, 0, 0, 0)
			ok = ps2000_get_timebase(ps2000_handle, timebase, no_of_values, time_interval, time_units, oversample, max_samples)
			ok = ps2000_set_trigger(ps2000_handle, 5, 0, 0, 0, 0)
			If ok = 0 Then
				MsgBox("No valid data to funktion set_trigger")
			End If
			lstChannelA.Items.Clear()
			ok = ps2000_run_block(ps2000_handle, no_of_values, timebase, oversample, time_indisposed)
			
			If ok > 0 Then
				
				Do 
					ready = ps2000_ready(ps2000_handle)
					If ready Then
						Exit Do
					End If
				Loop 
				Call ps2000_stop(ps2000_handle)
				
				ok = ps2000_get_values(ps2000_handle, Values_a(0), Values_b(0), Values_c(0), Values_d(0), overflow, 100)
				mv_a = voltage_range(cboVoltageA.SelectedIndex)
				For i = 0 To 99
					volts_a = (Values_a(i) / 32767) * (mv_a)
					lstChannelA.Items.Add((volts_a & " mV"))
				Next i
			Else
				lstMessage.Items.Clear()
				lstMessage.Items.Add(("Error running PS2000!"))
			End If
		Else
			lstMessage.Items.Clear()
			lstMessage.Items.Add(("Error running PS2000!"))
		End If
		
	End Sub
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		voltage_range(0) = 100
		voltage_range(1) = 200
		voltage_range(2) = 500
		voltage_range(3) = 1000
		voltage_range(4) = 2000
		voltage_range(5) = 5000
		voltage_range(6) = 10000
		voltage_range(7) = 20000
		
		'Channel
		cboVoltageA.Items.Insert(0, "100mV")
		cboVoltageA.Items.Insert(1, "200mV")
		cboVoltageA.Items.Insert(2, "500mv")
		cboVoltageA.Items.Insert(3, "1V")
		cboVoltageA.Items.Insert(4, "2V")
		cboVoltageA.Items.Insert(5, "5V")
		cboVoltageA.Items.Insert(6, "10V")
		cboVoltageA.Items.Insert(7, "20V")
		cboVoltageA.SelectedIndex = 7
		
		streaming = False
		
	End Sub
	
	Private Sub Open_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Open.Click
		
		Call open_unit()
		
	End Sub
	
	Private Sub Slow_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Slow.Click
		
		Dim ok As Short
		If ps2000_handle Then
			Slow.Enabled = False
			slow_collect = True
			lstChannelA.Items.Clear()
			streaming = False
		End If
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		Dim i As Object
		Dim ok As Short
		Dim overflow As Short
		Dim Values(1) As Short
		Dim no_of_values As Short
		Dim volts_a As Short
		Dim volts_b As Short
		Dim Values_a(1024) As Short
		Dim times(1024) As Integer
		Dim ready As Short
		
		If slow_collect Then
			no_of_values = 100
			If Not streaming Then
				Call ps2000_set_ets(ps2000_handle, 0, 0, 0)
				Call Channel_select_Click()
				ok = ps2000_set_trigger(ps2000_handle, 0, 0, 1, 0, 0)
				If ok = 0 Then
					MsgBox("No valid data to funktion set_trigger")
				End If
				ok = ps2000_run_streaming(ps2000_handle, 10, no_of_values, 0)
				streaming = True
			End If
			' turn triggering off.
			no_of_values = ps2000_get_values(ps2000_handle, Values_a(0), 0, 0, 0, overflow, no_of_values)
			mv_a = voltage_range(cboVoltageA.SelectedIndex)
			For i = 0 To no_of_values - 1 Step 1
				'UPGRADE_WARNING: Couldn't resolve default property of object i. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				volts_a = (Values_a(i) / 32767) * mv_a
				lstChannelA.Items.Add((volts_a & Chr(9) & "mV"))
			Next i
		End If
		
	End Sub
End Class